% this script generates CVs by clicking on a desired pixel on onset potential map
% before running this script, load Data.mat file into Matlab memory
% the script was tested in Matlab R2018a
% for any queries, email Slava (slava.shkirskiy@gmail.com) 04/05/2020


indX = 4;
indY = 4;


[~,~,ind] = size(Cur);
cur_line = NaN(1,ind);
pot_line = NaN(1,ind);

timeLine = 20;

indPix = 1;


while true

   
    zTitle = strcat('Onset Potential / V (vs Ag/AgCl)');

    Plot = Onset;
    
    subplot(1,2,1);

    surf(X,Y,Plot,'EdgeColor','none');
    view(2);

    colormap(jet); % good for current potential responses

    % format picture

    ax = gca;

    set(ax,'linewidth',3);
    set(ax,'fontsize',20);
    set(ax,'fontweight', 'bold');

    xlabel(['x / ',char(181),'m'], 'Interpreter', 'tex','FontName', 'Arial')
    ylabel(['y / ',char(181),'m'], 'Interpreter', 'tex', 'FontName', 'Arial')
    
    axis equal;
    axis tight;

    set(ax, 'TickDir', 'out');
    set(ax, 'TickLength', [0.02 0.02]);
    ax.XMinorTick = 'on';
    ax.YMinorTick = 'on';

    cbar=colorbar;

    cbar.TickLength = 0;
    cbar.LineWidth = 3;
    cbar.FontWeight = 'bold';
    cbar.FontSize = 20;

    cbar.Label.String = [zTitle];
    c.Label.FontName = 'Arial';

    caxis([-0.7 0]); % scale on colorbar
    

    for j=1:1:ind
        
        cur_line(j) = - Cur(indY,indX,j);
        pot_line(j) = - Vol(indY,indX,j);
        
        
    end
    
    
    subplot(1,2,2);
   
    plot(pot_line,cur_line,'o'); 
    
    
    xlabel('Potential / V (vs Ag/AgCl)');
    ylabel('Current / A');

    ax = gca;

    set(ax,'linewidth',3);
    set(ax,'fontsize',20);
    set(ax,'fontweight', 'bold');
    set(ax, 'TickDir', 'out');
    set(ax, 'TickLength', [0.02 0.02]);
    ax.XMinorTick = 'on';
    ax.YMinorTick = 'on';
    
    
    
    [pixel_x,pixel_y] = ginput(1);

    indX = floor((pixel_x - xMin)/hop_dist) + 1;
    indY = floor((pixel_y - yMin)/hop_dist) + 1;
    
    
end
